package com.izouma.jiashanxia.web;
import com.izouma.jiashanxia.domain.OrderInfo;
import com.izouma.jiashanxia.service.OrderInfoService;
import com.izouma.jiashanxia.dto.PageQuery;
import com.izouma.jiashanxia.exception.BusinessException;
import com.izouma.jiashanxia.repo.OrderInfoRepo;
import com.izouma.jiashanxia.utils.ObjUtils;
import com.izouma.jiashanxia.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/orderInfo")
@AllArgsConstructor
public class OrderInfoController extends BaseController {
    private OrderInfoService orderInfoService;
    private OrderInfoRepo orderInfoRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public OrderInfo save(@RequestBody OrderInfo record) {
        if (record.getId() != null) {
            OrderInfo orig = orderInfoRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return orderInfoRepo.save(orig);
        }
        return orderInfoRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<OrderInfo> all(@RequestBody PageQuery pageQuery) {
        return orderInfoService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public OrderInfo get(@PathVariable Long id) {
        return orderInfoRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        orderInfoRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<OrderInfo> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

